/*
This is a part of the mzscript LiteStep module source code.

Copyright (C) 2000-2003 The mzscript Development Team (see mzscript.txt)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _MZSCRIPT_BANGS_H
#define _MZSCRIPT_BANGS_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Includes
//
#include "common.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Function prototypes
//
tstring ParseBangParams(const char* pszArgs);

// variable related
void bangVarSet(HWND hCaller, const char* pszArgs);
void bangVarRemove(HWND hCaller, const char* pszArgs);

void bangVarAdd(HWND hCaller, const char* pszArgs);
void bangVarMul(HWND hCaller, const char* pszArgs);
void bangVarMod(HWND hCaller, const char* pszArgs);

// conditional statements
void bangIf(HWND hCaller, const char* pszArgs);

// miscellaneous
void bangExec(HWND hCaller, const char* pszArgs);
void bangMsgBox(HWND hCaller, const char* pszArgs);
void bangPause(HWND hCaller, const char* pszArgs);
void bangStatus(HWND hCaller, const char* pszArgs);


#endif // _MZSCRIPT_BANGS_H