/*
This is a part of the mzscript LiteStep module source code.

Copyright (C) 2000-2003 The mzscript Development Team (see mzscript.txt)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _MZSCRIPT_COMMON_H
#define _MZSCRIPT_COMMON_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Includes
//
//#include "../_common/AggressiveOptimize.h"
#include <litestep/lsapi/lsapi.h>

// M$ headers
#include <windows.h>
#include <tchar.h>

#pragma warning(push)
#pragma warning(disable: 4097 4514 4702 4710) // for warning level 4

#include <stdexcept>

// STL
#include <map>
#include <vector>
#include <string>

// boost.org
#include <boost/shared_ptr.hpp>
#include <boost/utility.hpp>

// safe(r) string functions
// http://msdn.microsoft.com/library/en-us/dnsecure/html/strsafe.asp
#define STRSAFE_NO_DEPRECATE
#include "strsafe.h"
#pragma warning(pop)


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// typedefs
//
typedef std::basic_string<TCHAR> tstring;


#endif // _MZSCRIPT_COMMON_H