#include "utility.h"
#include "common.h"

//--------------------

bool isnum(char *tmp)
{
    //Allow negative numbers
    if (strncmp(tmp, "-",1) == 0)
        ++tmp;
    //Stop null strings from returning true
    if (*tmp == '\0')
        return false;
    while (*tmp != '\0') {
        if (isdigit(*tmp) != 0)
            ++tmp;
        else
            return false;
    }
    return true;
}

//--------------------

int evalIf(char *e,char **theRet)
{
    assert(e != NULL);
    assert(theRet != NULL);
    
    char *first,*second,*cmp,*tmp,*tmp2,*ret;

    if (!e) return 0;
    *theRet=e;

    tmp = e;
    while (*tmp && *tmp!='\"') tmp++;
    if (!*tmp) {
        ErrorMessage("Missing quote in evalIf. Parameters: " + tstring(e));
        return 0;
    }
    first=++tmp;
    while (*tmp && *tmp!='\"') tmp++;
    if (!*tmp) {
        ErrorMessage("Missing quote in evalIf. Parameters: " + tstring(e));
        return 0;
    }
    *tmp++=0;
    cmp=tmp;
    while (*tmp && *tmp!='\"') tmp++;
    if (!*tmp) {
        ErrorMessage("Missing quote in evalIf. Parameters: " + tstring(e));
        return 0;
    }
    *tmp++=0;
    while (*cmp==' ' || *cmp=='\t') cmp++;
    tmp2 = cmp;
    while (*tmp2!=' ' && *tmp2!='\t') tmp2++;
    *tmp2=0;

    second = tmp;
    while (*tmp && *tmp!='\"') tmp++;
    if (!*tmp) {
        ErrorMessage("Missing quote in evalIf. Parameters: " + tstring(e));
        return 0;
    }
    *tmp++=0;
    ret=tmp;
    while (*ret==' ' || *ret=='\t'  || *ret==')') ret++;
    *theRet = ret;
    if (!lstrcmpi(cmp,"=")) {
		if (isnum(first) && isnum(second)) {
			if (atoi(first) == atoi(second))
				return 1;
		}
		else {
			if (!lstrcmpi(first,second))
				return 1;
		}
    } else if (!lstrcmpi(cmp,"<=")) {
		if (isnum(first) && isnum(second)) {
			if (atoi(first) <= atoi(second))
				return 1;
		}
		else {
			if (lstrcmpi(first,second)<=0)
				return 1;
		}
    } else if (!lstrcmpi(cmp,">=")) {
		if (isnum(first) && isnum(second)) {
			if (atoi(first) >= atoi(second))
				return 1;
		}
		else {
			if (lstrcmpi(first,second)>=0)
				return 1;
		}
    } else if (!lstrcmpi(cmp,"<")) {
        if (isnum(first) && isnum(second)) {
			if (atoi(first) < atoi(second))
				return 1;
		}
		else {
			if (lstrcmpi(first,second)<0)
				return 1;
		}
    } else if (!lstrcmpi(cmp,">")) {
        if (isnum(first) && isnum(second)) {
			if (atoi(first) > atoi(second))
				return 1;
		}
		else {
			if (lstrcmpi(first,second)>0)
				return 1;
		}
    } else if (!lstrcmpi(cmp,"<>")) {
        if (isnum(first) && isnum(second)) {
			if (atoi(first) != atoi(second))
				return 1;
		}
		else {
			if (lstrcmpi(first,second))
				return 1;
		}
    }

    return 0;
}
