/*
This is a part of the mzscript LiteStep module source code.

Copyright (C) 2000-2003 The mzscript Development Team (see mzscript.txt)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "varfuncs.h"
#include "variables.h"
#include "utility.h"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// SetupVarFuncs
//
void SetupVarFuncs()
{
    g_Variables->Set(_T("xresolution"), &funcXRes);
    g_Variables->Set(_T("yresolution"), &funcYRes);

    g_Variables->Set(_T("mousex"), &funcMouseX);
    g_Variables->Set(_T("mousey"), &funcMouseY);

    g_Variables->Set(_T("year"), &funcYear);
    g_Variables->Set(_T("month"), &funcMonth);
    g_Variables->Set(_T("day"), &funcDay);
    g_Variables->Set(_T("weekday"), &funcWeekday);
    g_Variables->Set(_T("hour"), &funcHour);
    g_Variables->Set(_T("minute"), &funcMin);
    g_Variables->Set(_T("second"), &funcSec);
    g_Variables->Set(_T("milli"), &funcMilli);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcXRes
//
tstring funcXRes()
{
    return string_cast(GetSystemMetrics(SM_CXSCREEN));
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcYRes
//
tstring funcYRes()
{
    return string_cast(GetSystemMetrics(SM_CYSCREEN));
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcMouseX
//
tstring funcMouseX()
{
    POINT p;
    GetCursorPos(&p);
    return string_cast(p.x);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcMouseY
//
tstring funcMouseY()
{
    POINT p;
    GetCursorPos(&p);
    return string_cast(p.y);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcYear
//
tstring funcYear()
{
    SYSTEMTIME systemTime;
    GetLocalTime(&systemTime);
    return string_cast(systemTime.wYear);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcMonth
//
tstring funcMonth()
{
    SYSTEMTIME systemTime;
    GetLocalTime(&systemTime);
    return string_cast(systemTime.wMonth);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcDay
//
tstring funcDay()
{
    SYSTEMTIME systemTime;
    GetLocalTime(&systemTime);
    return string_cast(systemTime.wDay);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcWeekday
//
tstring funcWeekday()
{
    SYSTEMTIME systemTime;
    GetLocalTime(&systemTime);
    return string_cast(systemTime.wDayOfWeek);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcHour
//
tstring funcHour()
{
    SYSTEMTIME systemTime;
    GetLocalTime(&systemTime);
    return string_cast(systemTime.wHour);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcMin
//
tstring funcMin()
{
    SYSTEMTIME systemTime;
    GetLocalTime(&systemTime);
    return string_cast(systemTime.wMinute);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcSec
//
tstring funcSec()
{
    SYSTEMTIME systemTime;
    GetLocalTime(&systemTime);
    return string_cast(systemTime.wSecond);
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// funcMilli
//
tstring funcMilli()
{
    SYSTEMTIME systemTime;
    GetLocalTime(&systemTime);
    return string_cast(systemTime.wMilliseconds);
}

